//+------------------------------------------------------------------+
//|                                            Moving Average HP.mq4 |
//|                                                 
//+------------------------------------------------------------------+
#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 Blue
#property indicator_width1 3
extern ENUM_TIMEFRAMES TimeFrame=PERIOD_CURRENT;
extern double w=0.1;
extern bool   Interpolate = true;
double MA[]; 
string indicatorFileName;
bool   returnBars;
int start()
{
   int counted_bars = IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars > 0) counted_bars--;
          int limit=MathMin(Bars-counted_bars,Bars-1);
          if (returnBars) { MA[0] = limit; return(0); }

   //
   //
   //
   //
   //

   if (TimeFrame == _Period)
   {
      for(int i=limit; i>=0; i--)
      {
         if (i>=Bars-2) { MA[i]=Open[i]; continue; }
	                       MA[i]=w*(Open[i]-2.*MA[i+1]+MA[i+2])+2.*MA[i+1]-MA[i+2];	 
      }	                       
	   return(0);
   }
   
   //
   //
   //
   //
   //
   
   limit = (int)MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/Period()));
   for(i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,TimeFrame,Time[i]);
         MA[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,w,0,y);
         if (!Interpolate || (i>0 && y==iBarShift(NULL,TimeFrame,Time[i-1]))) continue;
                  
         //
         //
         //
         //
         //
                  
         int n,k; datetime time = iTime(NULL,TimeFrame,y);
            for(n = 1; (i+n)<Bars && Time[i+n] >= time; n++) continue;	
            for(k = 1; k<n && (i+n)<Bars && (i+k)<Bars; k++) MA[i+k] = MA[i] + (MA[i+n] - MA[i]) * k/n;
   }      
   return(0);	   
}
int init()
{
   SetIndexBuffer(0,MA);
      indicatorFileName = WindowExpertName();
      returnBars        = TimeFrame==-99;
      TimeFrame         = MathMax(TimeFrame,_Period);
   return(0);
}


